/*
**    Copyright 2009 Sogame
**
**    This file is part of withAttach.
**
**    withAttach is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    withAttach is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with withAttach. If not, see <http://www.gnu.org/licenses/>.
*/


var withAttachOps = {
	initialized: false,
	wa_def_prefs: Array(),
	_wa_prefs: Array(),
	
	
	init: function() {
		withAttachOps.wa_def_prefs["scan"] = true;
		withAttachOps.wa_def_prefs["keywords"] = "attach.*,files?,photo(graph)?s?";
		withAttachOps.wa_def_prefs["write_bnt"] = true;
		withAttachOps.wa_def_prefs["enabled_default"] = false;
		withAttachOps.wa_def_prefs["alert_label"] = true;
		
		withAttachOps.initialized = true;
		
		withAttachOps._wa_prefs = withAttachOps.loadPrefs();
	},
	
	
	loadPrefs: function() {
		var arr = Array();
		try {
			//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			//if (prefs.prefHasUserValue("witattach.scan")) {
			if (nsPreferences.mPrefService.prefHasUserValue("witattach.scan")) {
				//arr["scan"] = prefs.getBoolPref("witattach.scan");
				arr["scan"] = nsPreferences.getBoolPref("witattach.scan");
			}
			else {
				//prefs.setBoolPref("witattach.scan", wa_def_prefs["scan"]);
				nsPreferences.setBoolPref("witattach.scan", withAttachOps.wa_def_prefs["scan"]);
				arr["scan"] = withAttachOps.wa_def_prefs["scan"];
			}
			
			//if (prefs.prefHasUserValue("witattach.keywords")) {
			if (nsPreferences.mPrefService.prefHasUserValue("witattach.keywords")) {
				//arr["keywords"] = prefs.getCharPref("witattach.keywords").toLowerCase();
				arr["keywords"] = nsPreferences.getLocalizedUnicharPref("witattach.keywords").toLowerCase();
				arr["keywords"] = withAttachOps.waTrim(arr["keywords"]);
			}
			else {
				//prefs.setCharPref("witattach.keywords", wa_def_prefs["keywords"]);
				nsPreferences.setUnicharPref("witattach.keywords", withAttachOps.wa_def_prefs["keywords"]);
				arr["keywords"] = withAttachOps.wa_def_prefs["keywords"];
			}
			
			if (nsPreferences.mPrefService.prefHasUserValue("witattach.write_bnt")) {
				arr["write_bnt"] = nsPreferences.getBoolPref("witattach.write_bnt");
			}
			else {
				nsPreferences.setBoolPref("witattach.write_bnt", withAttachOps.wa_def_prefs["write_bnt"]);
				arr["write_bnt"] = withAttachOps.wa_def_prefs["write_bnt"];
			}
			
			if (nsPreferences.mPrefService.prefHasUserValue("witattach.enabled_default")) {
				arr["enabled_default"] = nsPreferences.getBoolPref("witattach.enabled_default");
			}
			else {
				nsPreferences.setBoolPref("witattach.enabled_default", withAttachOps.wa_def_prefs["enabled_default"]);
				arr["enabled_default"] = withAttachOps.wa_def_prefs["enabled_default"];
			}
			
			if (nsPreferences.mPrefService.prefHasUserValue("witattach.alert_label")) {
				arr["alert_label"] = nsPreferences.getBoolPref("witattach.alert_label");
			}
			else {
				nsPreferences.setBoolPref("witattach.alert_label", withAttachOps.wa_def_prefs["alert_label"]);
				arr["alert_label"] = withAttachOps.wa_def_prefs["alert_label"];
			}
			
			return arr;
		}
		catch(e) {
			alert("Preferences error\n" + e.name + ": " + e.message);
			return arr;
		}
	},
	
	
	waShowPrefsValues: function(doc) {
		var elem;
		elem = doc.getElementById("wa_scan_enabled");
		if (withAttachOps._wa_prefs["scan"]) {
			elem.checked = true;
		}
		else {
			elem.checked = false;
		}
		
		elem = doc.getElementById("wa_keywords");
		elem.value = withAttachOps._wa_prefs["keywords"];
		
		elem = doc.getElementById("wa_show_write_bnt");
		if (withAttachOps._wa_prefs["write_bnt"]) {
			elem.checked = true;
		}
		else {
			elem.checked = false;
		}
		
		elem = doc.getElementById("wa_enabled_default");
		if (withAttachOps._wa_prefs["enabled_default"]) {
			elem.checked = true;
		}
		else {
			elem.checked = false;
		}
		
		elem = doc.getElementById("wa_show_alert_label");
		if (withAttachOps._wa_prefs["alert_label"]) {
			elem.checked = true;
		}
		else {
			elem.checked = false;
		}
	},
	
	
	waSaveOptions: function() {
		try {
			var elem;
			var val;
			//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			
			elem = document.getElementById("wa_scan_enabled");
			val = (elem.checked) ? true : false;
			//prefs.setBoolPref("witattach.scan", val);
			nsPreferences.setBoolPref("witattach.scan", val);
			
			elem = document.getElementById("wa_keywords");
			var val = elem.value;
			val = val.toLowerCase();
			val = withAttachOps.waTrim(val);
			//prefs.setCharPref("witattach.keywords", val);
			nsPreferences.setUnicharPref("witattach.keywords", val);
			
			elem = document.getElementById("wa_show_write_bnt");
			val = (elem.checked) ? true : false;
			nsPreferences.setBoolPref("witattach.write_bnt", val);
			
			elem = document.getElementById("wa_enabled_default");
			val = (elem.checked) ? true : false;
			nsPreferences.setBoolPref("witattach.enabled_default", val);

			elem = document.getElementById("wa_show_alert_label");
			val = (elem.checked) ? true : false;
			nsPreferences.setBoolPref("witattach.alert_label", val);
			
			window.close();
		}
		catch(e) {
			alert("Preferences error\n" + e.name + ": " + e.message);
		}
	},
	
	
	waTrim: function(s) {
	  while (s.substring(0,1) == ' ') {
		s = s.substring(1,s.length);
	  }
	  while (s.substring(s.length-1,s.length) == ' ') {
		s = s.substring(0,s.length-1);
	  }
	  return s;
	}
}
