/*
**    Copyright 2009 Sogame
**
**    This file is part of withAttach.
**
**    withAttach is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    withAttach is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with withAttach. If not, see <http://www.gnu.org/licenses/>.
*/

var withAttachCompose = {
	initialized: false,
	wa_mail_with_attach: false,
	wa_gMsgCompose_orig: null,
	
	init: function() {
		window.removeEventListener("load", withAttachCompose.init, true);
		
		withAttachCompose.clearInternalVars();
		
		if (nsPreferences.getBoolPref("withAttach.mail_with_attach") || nsPreferences.getBoolPref("witattach.enabled_default")) {
			withAttachCompose.wa_mail_with_attach = true;
			withAttachCompose.waClearFlag();
		}
		
		withAttachCompose.initialized = true;
		
		withAttachCompose.waComposeLoad();
	},
	
	
	clearInternalVars: function() {
		withAttachCompose.wa_mail_with_attach = false;
		withAttachCompose.wa_gMsgCompose_orig = null;
	},
	
	
	waComposeLoad: function() {
		if (!withAttachCompose.initialized) {
			withAttachCompose.init();
		}
		else {
			/*
			if (nsPreferences.mPrefService.prefHasUserValue("withAttach.mail_with_attach")) {
				if (nsPreferences.getBoolPref("withAttach.mail_with_attach")) {
					wa_mail_with_attach = true;
				}
			}
			*/
			//if (nsPreferences.getBoolPref("withAttach.mail_with_attach") || nsPreferences.getBoolPref("witattach.enabled_default")) {
			/*
			if (nsPreferences.getBoolPref("withAttach.mail_with_attach")) {
				withAttachCompose.wa_mail_with_attach = true;
				withAttachCompose.waClearFlag();
			}
			
			var elem = document.getElementById("withattach-button-toggle-flag");
			if (elem != null) {
				elem.checked = withAttachCompose.wa_mail_with_attach;
			}
			*/
			
			withAttachCompose.waUpdateVisualElemetents();
			
			/*
			// Add button to toolbar
			try {
				toggle_flag_first_added = false;
				if (nsPreferences.mPrefService.prefHasUserValue("witattach.toggle_flag_first_added")) {
					toggle_flag_first_added = nsPreferences.getBoolPref("witattach.toggle_flag_first_added");
				}
				if (!toggle_flag_first_added) {
					toggle_flag_first_added = true;
					nsPreferences.setBoolPref("witattach.toggle_flag_first_added", true);
					
					var elem = document.getElementById("withattach-button-toggle-flag");
					if (elem == null) {
						var button = document.createElement("toolbarbutton");
						button.setAttribute("id", "withattach-button-toggle-flag");
						button.setAttribute("class", "toolbarbutton-1");
						button.setAttribute("label", "withAttach");
						button.setAttribute("type", "checkbox");
						button.setAttribute("oncommand", "waToggleFlag();");
						var next = document.getElementById("button-send");
						next.parentNode.insertBefore(button, next);
					}
				}
			}
			catch (e) {
			}
			*/
		}
	},
	
	
	// Toggle withattach flasg (using the button in the compose window)
	waToggleFlag: function() {
		var elem = document.getElementById("withattach-button-toggle-flag");
		if (elem != null) {
			withAttachCompose.wa_mail_with_attach = !elem.checked;
		}
		withAttachCompose.waUpdateVisualElemetents();
	},
	
	
	// Show/hide the warning in the compose window
	toggleWithAttachLabel: function() {
		/*
		//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		//if (prefs.prefHasUserValue("withAttach.mail_with_attach")) {
		if (nsPreferences.mPrefService.prefHasUserValue("withAttach.mail_with_attach")) {
			var elem = document.getElementById("wa-mail_compose_label");
			var hidden = true;
			//if (prefs.getBoolPref("withAttach.mail_with_attach")) {
			if (nsPreferences.getBoolPref("withAttach.mail_with_attach")) {
				var bucketList = document.getElementById("attachmentBucket");
				if ((bucketList == null) || ((bucketList != null) && (bucketList.getRowCount() <= 0))) {
					hidden = false;
				}
			}
			elem.hidden = hidden;
		}
		*/
		var elem = document.getElementById("wa-mail_compose_label");
		var hidden = true;
		if (withAttachCompose.wa_mail_with_attach && nsPreferences.getBoolPref("witattach.alert_label")) {
			var bucketList = document.getElementById("attachmentBucket");
			if ((bucketList == null) || ((bucketList != null) && (bucketList.getRowCount() <= 0))) {
				hidden = false;
			}
		}
		elem.hidden = hidden;
	},
	
	
	// Show/hidde the attachment bucket when the message window is opened (when needed)
	waOpenAttachmentBucket: function() {
		/*
		//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		//if (prefs.prefHasUserValue("withAttach.mail_with_attach") && prefs.getBoolPref("withAttach.mail_with_attach")) {
		if (nsPreferences.mPrefService.prefHasUserValue("withAttach.mail_with_attach") && nsPreferences.getBoolPref("withAttach.mail_with_attach")) {
			// Show the attachment bucket
			ChangeAttachmentBucketVisibility(false);
		}
		*/
		if (withAttachCompose.wa_mail_with_attach) {
			// Show the attachment bucket
			ChangeAttachmentBucketVisibility(false);
		}
		else {
			// Hide the attachment bucket?
			var bucketList = document.getElementById("attachmentBucket");
			if ((bucketList == null) || ((bucketList != null) && (bucketList.getRowCount() <= 0))) {
				// The attachment bucket is empty: hide the attachment bucket
				ChangeAttachmentBucketVisibility(true);
			}
		}
	},
	
	
	// Check/uncheck the toggle button in the compose window
	toggleComposeFlagBtn: function() {
		var elem = document.getElementById("withattach-button-toggle-flag");
		if (elem != null) {
			elem.checked = withAttachCompose.wa_mail_with_attach;
		}
	},
	
	
	// Update withAttach visual elements
	waUpdateVisualElemetents: function() {
		//if (nsPreferences.getBoolPref("withAttach.mail_with_attach") || nsPreferences.getBoolPref("witattach.enabled_default")) {
		/*
		if (nsPreferences.getBoolPref("withAttach.mail_with_attach")) {
			withAttachCompose.wa_mail_with_attach = true;
			withAttachCompose.waClearFlag();
		}
		*/
		
		withAttachCompose.toggleWithAttachLabel();
		withAttachCompose.waOpenAttachmentBucket();
		withAttachCompose.toggleComposeFlagBtn();
	},
	
	
	waCloseComposeWindow: function() {
		withAttachCompose.clearInternalVars();
	},
	
	
	waCheckSendMail: function() {
		var msgcomposeWindow = document.getElementById("msgcomposeWindow");
		var msgtype = msgcomposeWindow.getAttribute("msgtype");
		if ((msgtype != nsIMsgCompDeliverMode.Save) && (msgtype != nsIMsgCompDeliverMode.SaveAsDraft) && (msgtype != nsIMsgCompDeliverMode.AutoSaveAsDraft) && (msgtype != nsIMsgCompDeliverMode.SaveAsTemplate)) {
			// Check attachments only if not saving

//gAutoSaving = (msgType == nsIMsgCompDeliverMode.AutoSaveAsDraft);
		//msgType == nsIMsgCompDeliverMode.AutoSaveAsDraft
		//var 
		//if (!gSendOrSaveOperationInProgress) {
		//if (gSendOrSaveOperationInProgress) {
			//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			var wa_mail = false;
			/*
			//if (prefs.prefHasUserValue("withAttach.mail_with_attach")) {
			if (nsPreferences.mPrefService.prefHasUserValue("withAttach.mail_with_attach")) {
				//if (prefs.getBoolPref("withAttach.mail_with_attach")) {
				if (nsPreferences.getBoolPref("withAttach.mail_with_attach")) {
					wa_mail = true;
					var bucketList = document.getElementById("attachmentBucket");
					if ((bucketList == null) || ((bucketList != null) && (bucketList.getRowCount() <= 0))) {
						// No attachements found, prompt user
						var wa_bundle = document.getElementById("bundle_withattach");
						var wa_title = wa_bundle.getString("wa-title");
						var wa_msg = wa_bundle.getString("wa-no_attach");
						if (!gPromptService.confirm(window, wa_title, wa_msg)) {
							waCancelSending();
						}
						else {
							waClearFlag();
						}
					}
				}
			}
			*/
			if (withAttachCompose.wa_mail_with_attach) {
				wa_mail = true;
				var bucketList = document.getElementById("attachmentBucket");
				if ((bucketList == null) || ((bucketList != null) && (bucketList.getRowCount() <= 0))) {
					// No attachements found, prompt user
					var wa_bundle = document.getElementById("bundle_withattach");
					var wa_title = wa_bundle.getString("wa-title");
					var wa_msg = wa_bundle.getString("wa-no_attach");
					if (!gPromptService.confirm(window, wa_title, wa_msg)) {
						withAttachCompose.waCancelSending();
					}
					/*
					else {
						withAttachCompose.waClearFlag();
					}
					*/
				}
			}
			
			if (!wa_mail) {
				// Scan mail, search keywords
				var _wa_prefs = withAttachOps.loadPrefs();
				if (_wa_prefs["scan"]) {
					var content_frame = document.getElementById('content-frame');
					var orig_mail_body = content_frame.contentDocument.getElementsByTagName('body')[0];
					//var mail_body = orig_mail_body.cloneNode(true);
					//mail_body = mail_body.innerHTML.toLowerCase();
					var editor = GetCurrentEditor();
					var mail_body = editor.outputToString("text/plain", "");
					// Remove quoted (reply to)  messages
					var re = /\n\s*>.*[\r\n]/g;
					mail_body = mail_body.replace(re, " \r\n ");
					mail_body = mail_body.toLowerCase();
					
					var mail_subject = document.getElementById("msgSubject").value;
					mail_body = ' ' + mail_subject + ' ' + mail_body + ' ';
					// Replace some chars
					mail_body = withAttachCompose.waReplaceAll(mail_body, "&nbsp;", " ");
					mail_body = withAttachCompose.waReplaceAll(mail_body, "\r", " ");
					mail_body = withAttachCompose.waReplaceAll(mail_body, "\n", " ");
					mail_body = withAttachCompose.waReplaceAll(mail_body, ".", " ");
					mail_body = withAttachCompose.waReplaceAll(mail_body, ",", " ");
					mail_body = withAttachCompose.waReplaceAll(mail_body, ";", " ");
					mail_body = withAttachCompose.waReplaceAll(mail_body, "<", " ");
					mail_body = withAttachCompose.waReplaceAll(mail_body, ">", " ");
					
					var wa_keywords = _wa_prefs["keywords"].split(',');
					var wa_scan_match = false;
					for (i=0; (i<wa_keywords.length) && !wa_scan_match; i++) {
						wa_keywords[i] = ' ' + withAttachOps.waTrim(wa_keywords[i]) + ' ';
						wa_scan_match = (mail_body.match(wa_keywords[i]) != null);
					}
					if (wa_scan_match) {
						// Match found, get number of attached files
						var bucketList = document.getElementById("attachmentBucket");
						if ((bucketList == null) || ((bucketList != null) && (bucketList.getRowCount() <= 0))) {
							// No attachements found, prompt user
							var wa_bundle = document.getElementById("bundle_withattach");
							var wa_title = wa_bundle.getString("wa-title");
							var wa_msg = wa_bundle.getString("wa-no_attach_scan");
							if (!gPromptService.confirm(window, wa_title, wa_msg)) {
								withAttachCompose.waCancelSending();
							}
							/*
							else {
								withAttachCompose.waClearFlag();
							}
							*/
						}
					}
				}
			}
		//}
		}
	},
	
	
	waReplaceAll: function(streng, soeg, erstat) {
		var st = streng;
		if (soeg.length == 0)
			return st;
		var idx = st.indexOf(soeg);
		while (idx >= 0) {
			st = st.substring(0, idx) + erstat + st.substr(idx + soeg.length);
			idx = st.indexOf(soeg);
		}
		return st;
	},
	
	
	waCancelSending: function() {
		if (gMsgCompose != null) {
			withAttachCompose.wa_gMsgCompose_orig = gMsgCompose;
		}
		gMsgCompose = null;
		window.setTimeout(withAttachCompose.waRestore_gMsgCompose, 1000);
	},
	
	
	waRestore_gMsgCompose: function() {
		if (withAttachCompose.wa_gMsgCompose_orig != null) {
			gMsgCompose = withAttachCompose.wa_gMsgCompose_orig;
		}
	},
	
	
	// Remove withAttach flag
	waClearFlag: function() {
		/*
		//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		//if (prefs.prefHasUserValue("withAttach.mail_with_attach")) {
		if (nsPreferences.mPrefService.prefHasUserValue("withAttach.mail_with_attach")) {
		  //prefs.setBoolPref("withAttach.mail_with_attach", false);
		  nsPreferences.setBoolPref("withAttach.mail_with_attach", false);
		}
		*/
		nsPreferences.setBoolPref("withAttach.mail_with_attach", false);
	}
};


//window.addEventListener("load", withAttachCompose.init, true);
window.addEventListener("compose-window-init", withAttachCompose.init, true);


//window.addEventListener("load", waOpenAttachmentBucket, true);
//window.addEventListener("load", waComposeLoad, true);
//window.addEventListener("close", waClearFlag, true);    // This is not needed. The flag is not stored in preferences anymore.
window.addEventListener("close", withAttachCompose.waCloseComposeWindow, true);
//window.addEventListener("focus", toggleWithAttachLabel, true);
//window.addEventListener("focus", waUpdateVisualElemetents, true);
window.addEventListener("focus", withAttachCompose.waComposeLoad, true);
window.addEventListener("compose-send-message", withAttachCompose.waCheckSendMail, true);
//window.addEventListener("compose-window-close", waClearFlag, true);





// ///////////////////////////////////////////////////////////////////////////// //
// ///////////////////////////////////////////////////////////////////////////// //
// Functions copied from "content\messenger\messengercompose\MsgComposeCommands.js"  //
// ///////////////////////////////////////////////////////////////////////////// //
// ///////////////////////////////////////////////////////////////////////////// //

function ChangeAttachmentBucketVisibility(aHideBucket) {
  document.getElementById("attachments-box").collapsed = aHideBucket;
  document.getElementById("attachmentbucket-sizer").collapsed = aHideBucket;
  // ////////////
  // [SOGAME] //
  // ////////////
  withAttachCompose.toggleWithAttachLabel();
  // /////////////
  // [/SOGAME] //
  // /////////////
}



/*
function GenericSendMessage( msgType )
{
  // ////////////
  // [SOGAME] //
  // ////////////
  //var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  //if (prefs.prefHasUserValue("withAttach.mail_with_attach")) {
  if (nsPreferences.mPrefService.prefHasUserValue("withAttach.mail_with_attach")) {
    //if (prefs.getBoolPref("withAttach.mail_with_attach")) {
    if (nsPreferences.getBoolPref("withAttach.mail_with_attach")) {
      var bucketList = document.getElementById("attachmentBucket");
      if ((bucketList == null) || ((bucketList != null) && (bucketList.getRowCount() <= 0))) {
        var wa_bundle = document.getElementById("bundle_withattach");
        var wa_title = wa_bundle.getString("wa-title");
        var wa_msg = wa_bundle.getString("wa-no_attach");
        if (!gPromptService.confirm(window, wa_title, wa_msg)) {
          return;
        }
      }
    }
  }
  // /////////////
  // [/SOGAME] //
  // /////////////

  dump("GenericSendMessage from XUL\n");

  dump("Identity = " + getCurrentIdentity() + "\n");

  if (gMsgCompose != null)
  {
    var msgCompFields = gMsgCompose.compFields;
    if (msgCompFields)
    {
      Recipients2CompFields(msgCompFields);
      var subject = document.getElementById("msgSubject").value;
      msgCompFields.subject = subject;
      Attachments2CompFields(msgCompFields);

      if (msgType == nsIMsgCompDeliverMode.Now || msgType == nsIMsgCompDeliverMode.Later)
      {
        //Do we need to check the spelling?
        if (sPrefs.getBoolPref("mail.SpellCheckBeforeSend")) 
        {
          //We disable spellcheck for the following -subject line, attachment pane, identity and addressing widget
          //therefore we need to explicitly focus on the mail body when we have to do a spellcheck.
          window.content.focus();
          window.cancelSendMessage = false;
          try {
            window.openDialog("chrome://editor/content/EdSpellCheck.xul", "_blank",
                    "chrome,close,titlebar,modal", true, true);
          }
          catch(ex){}
          if(window.cancelSendMessage)
            return;
         }

         //Check if we have a subject, else ask user for confirmation
         if (subject == "")
         {
           if (gPromptService)
           {            
             var result = {value:sComposeMsgsBundle.getString("defaultSubject")};
             if (gPromptService.prompt(
                window,
                sComposeMsgsBundle.getString("sendMsgTitle"),
                sComposeMsgsBundle.getString("subjectDlogMessage"),
                result,
                null,
                {value:0}))
             {
               msgCompFields.subject = result.value;
               var subjectInputElem = document.getElementById("msgSubject");
               subjectInputElem.value = result.value;
             }
             else
               return;
            }
          }

          // check if the user tries to send a message to a newsgroup through a mail account
          var currentAccountKey = getCurrentAccountKey();
          var account = gAccountManager.getAccount(currentAccountKey);
          if (!account)
          {
            throw "UNEXPECTED: currentAccountKey '" + currentAccountKey +
                "' has no matching account!";
          }
          var servertype = account.incomingServer.type;

          if (servertype != "nntp" && msgCompFields.newsgroups != "")
          {
            // default to ask user if the pref is not set
            var dontAskAgain = sPrefs.getBoolPref("mail.compose.dontWarnMail2Newsgroup");

            if (!dontAskAgain)
            {
              var checkbox = {value:false};
              var okToProceed = gPromptService.confirmCheck(window,
                                                            sComposeMsgsBundle.getString("sendMsgTitle"),
                                                            sComposeMsgsBundle.getString("recipientDlogMessage"),
                                                            sComposeMsgsBundle.getString("CheckMsg"), checkbox);

              if (!okToProceed)
                return;

              if (checkbox.value)
                sPrefs.setBoolPref(kDontAskAgainPref, true);
            }

            // remove newsgroups to prevent news_p to be set 
            // in nsMsgComposeAndSend::DeliverMessage()
            msgCompFields.newsgroups = "";
          }

          // Before sending the message, check what to do with HTML message, eventually abort.
          var convert = DetermineConvertibility();
          var action = DetermineHTMLAction(convert);
         // check if e-mail addresses are complete, in case user
         // has turned off autocomplete to local domain.
         if (!CheckValidEmailAddress(msgCompFields.to, msgCompFields.cc, msgCompFields.bcc))
          return;

          if (action == nsIMsgCompSendFormat.AskUser)
          {
            var recommAction = convert == nsIMsgCompConvertible.No
                           ? nsIMsgCompSendFormat.AskUser
                           : nsIMsgCompSendFormat.PlainText;
            var result2 = {action:recommAction,
                          convertible:convert,
                          abort:false};
            window.openDialog("chrome://messenger/content/messengercompose/askSendFormat.xul",
                              "askSendFormatDialog", "chrome,modal,titlebar,centerscreen",
                              result2);
            if (result2.abort)
              return;
            action = result2.action;
          }
          
          // we will remember the users "send format" decision
          // in the address collector code (see nsAbAddressCollecter::CollectAddress())
          // by using msgCompFields.forcePlainText and msgCompFields.useMultipartAlternative
          // to determine the nsIAbPreferMailFormat (unknown, plaintext, or html)
          // if the user sends both, we remember html.

          switch (action)
          {
            case nsIMsgCompSendFormat.PlainText:
              msgCompFields.forcePlainText = true;
              msgCompFields.useMultipartAlternative = false;
              break;
            case nsIMsgCompSendFormat.HTML:
              msgCompFields.forcePlainText = false;
              msgCompFields.useMultipartAlternative = false;
              break;
            case nsIMsgCompSendFormat.Both:
              msgCompFields.forcePlainText = false;
              msgCompFields.useMultipartAlternative = true;
              break;
             default: dump("\###SendMessage Error: invalid action value\n"); return;
          }
      }

      // hook for extra compose pre-processing
      var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
      observerService.notifyObservers(window, "mail:composeOnSend", null);

      // Check if the headers of composing mail can be converted to a mail charset.
      if (msgType == nsIMsgCompDeliverMode.Now || 
        msgType == nsIMsgCompDeliverMode.Later ||
        msgType == nsIMsgCompDeliverMode.Save || 
        msgType == nsIMsgCompDeliverMode.SaveAsDraft || 
        msgType == nsIMsgCompDeliverMode.AutoSaveAsDraft || 
        msgType == nsIMsgCompDeliverMode.SaveAsTemplate) 
      {
        var fallbackCharset = new Object;
        if (gPromptService && 
            !gMsgCompose.checkCharsetConversion(getCurrentIdentity(), fallbackCharset)) 
        {
          var dlgTitle = sComposeMsgsBundle.getString("initErrorDlogTitle");
          var dlgText = sComposeMsgsBundle.getString("12553");  // NS_ERROR_MSG_MULTILINGUAL_SEND
          var result3 = gPromptService.confirmEx(window, dlgTitle, dlgText,
              (gPromptService.BUTTON_TITLE_IS_STRING * gPromptService.BUTTON_POS_0) +
              (gPromptService.BUTTON_TITLE_IS_STRING * gPromptService.BUTTON_POS_1) +
              (gPromptService.BUTTON_TITLE_CANCEL * gPromptService.BUTTON_POS_2),
              sComposeMsgsBundle.getString('sendInUTF8'), 
              sComposeMsgsBundle.getString('sendAnyway'),
              null, null, {value:0}); 
          switch(result3)
          {
            case 0: 
              fallbackCharset.value = "UTF-8";
              break;
            case 1:  // send anyway
              msgCompFields.needToCheckCharset = false;
              break;
            case 2:  // cancel
              return;
          }
        }
        if (fallbackCharset && 
            fallbackCharset.value && fallbackCharset.value != "")
          gMsgCompose.SetDocumentCharset(fallbackCharset.value);
      }
      try {

        // just before we try to send the message, fire off the compose-send-message event for listeners
        // such as smime so they can do any pre-security work such as fetching certificates before sending
        var event = document.createEvent('Events');
        event.initEvent('compose-send-message', false, true);
        document.getElementById("msgcomposeWindow").dispatchEvent(event);

        gWindowLocked = true;
        disableEditableFields();
        updateComposeItems();

        var progress = Components.classes["@mozilla.org/messenger/progress;1"].createInstance(Components.interfaces.nsIMsgProgress);
        if (progress)
        {
          progress.registerListener(progressListener);
          gSendOrSaveOperationInProgress = true;
        }
        msgWindow.SetDOMWindow(window);
        msgWindow.rootDocShell.allowAuth = true;
        // ////////////
        // [SOGAME] //
        // ////////////
        //var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        //if (prefs.prefHasUserValue("withAttach.mail_with_attach")) {
        if (nsPreferences.mPrefService.prefHasUserValue("withAttach.mail_with_attach")) {
          //prefs.setBoolPref("withAttach.mail_with_attach", false);
          nsPreferences.setBoolPref("withAttach.mail_with_attach", false);
        }
        // /////////////
        // [/SOGAME] //
        // /////////////
        gMsgCompose.SendMsg(msgType, getCurrentIdentity(), currentAccountKey, msgWindow, progress);
      }
      catch (ex) {
        dump("failed to SendMsg: " + ex + "\n");
        gWindowLocked = false;
        enableEditableFields();
        updateComposeItems();
      }
    }
  }
  else
    dump("###SendMessage Error: composeAppCore is null!\n");
}
*/

/*
function MsgComposeCloseWindow(recycleIt)
{
  if (gMsgCompose) {
    // ////////////
    // [SOGAME] //
    // ////////////
	waClearFlag();
    // /////////////
    // [/SOGAME] //
    // /////////////
    gMsgCompose.CloseWindow(recycleIt);
  }
}
*/