/*
**    Copyright 2009 Sogame
**
**    This file is part of withAttach.
**
**    withAttach is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    withAttach is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with withAttach. If not, see <http://www.gnu.org/licenses/>.
*/

var withAttach = {
	init: function() {
		var id_reply_all_elem = "mailContext-replyAll"; // TB 3.0
		var id_reply_list_elem = "mailContext-replyList"; // TB 3.0
		var menu = document.getElementById("mailContext"); // TB 3.0
		if (menu == null) {
			menu = document.getElementById("threadPaneContext"); // TB 2.0
			id_reply_all_elem = "threadPaneContext-replyAll"; // TB 2.0
			id_reply_list_elem = "threadPaneContext-forward"; // TB 2.0 (no "reply to list" option, so "forward" is used)
		}
		
		if (menu != null) {
			menu.addEventListener("popupshowing", withAttach.showContextMenu, false);
			
			var wa_bundle = document.getElementById("bundle_withattach");
			var label_reply = wa_bundle.getString("wa-reply");
			var label_replyall = wa_bundle.getString("wa-reply_all");
			
			//var contextMenu = document.getElementById("threadPaneContext");
			var contextMenu = menu;
			var menuitemWAreply = document.createElement("menuitem");
			menuitemWAreply.setAttribute("id", "waContextReply");
			menuitemWAreply.setAttribute("label", label_reply);
			menuitemWAreply.setAttribute("oncommand", "withAttach.replyMail();");
			var menuitemWAreplyall = document.createElement("menuitem");
			menuitemWAreplyall.setAttribute("id", "waContextReplyAll");
			menuitemWAreplyall.setAttribute("label", label_replyall);
			menuitemWAreplyall.setAttribute("oncommand", "withAttach.replyAllMail();");
			var insertPos = document.getElementById(id_reply_all_elem);
			contextMenu.insertBefore(menuitemWAreply, insertPos);
			insertPos = document.getElementById(id_reply_list_elem);
			contextMenu.insertBefore(menuitemWAreplyall, insertPos);
		}
		
		try {
			if (nsPreferences.mPrefService.prefHasUserValue("witattach.write_bnt")) {
				if (!nsPreferences.getBoolPref("witattach.write_bnt")) {
					var elem = document.getElementById("wa_writewa_menuitem");
					elem.parentNode.parentNode.removeChild(elem.parentNode);
				}
			}
		}
		catch (e) {
		}
	},
	
	newMail: function() {
		//this.setWithAttach();
		withAttach.setWithAttach();
		window.parent.MsgNewMessage(null);
	},
	
	replyMail: function() {
		//this.setWithAttach();
		withAttach.setWithAttach();
		MsgReplyMessage(null);
	},
	
	replyAllMail: function() {
		//this.setWithAttach();
		withAttach.setWithAttach();
		MsgReplyToAllMessage(null);
	},

	showContextMenu: function() {
		var numSelected = GetNumSelectedMessages();
		var hidden = (numSelected <= 0);
		var elem = document.getElementById("waContextReply");
		if (elem != null) {
			elem.setAttribute('disabled', hidden ? 'true' : '');
		}
		elem = document.getElementById("waContextReplyAll");
		if (elem != null) {
			elem.setAttribute('disabled', hidden ? 'true' : '');
		}
	},
	
	setWithAttach: function() {
		//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		//prefs.setBoolPref("withAttach.mail_with_attach", true);
		nsPreferences.setBoolPref("withAttach.mail_with_attach", true);
	},
	
	clearWithAttach: function() {
		//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		//prefs.setBoolPref("withAttach.mail_with_attach", false);
		nsPreferences.setBoolPref("withAttach.mail_with_attach", false);
	}
};


/*
//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
//if (prefs.prefHasUserValue("withAttach.mail_with_attach")) {
if (nsPreferences.mPrefService.prefHasUserValue("withAttach.mail_with_attach")) {
//	prefs.setBoolPref("withAttach.mail_with_attach", false);
	nsPreferences.setBoolPref("withAttach.mail_with_attach", false);
}
*/
nsPreferences.setBoolPref("withAttach.mail_with_attach", false);


window.addEventListener("load", withAttach.init, false);
